- [HTTP request](https://docs.cloud.google.com/compute/docs/reference/rest/v1/reservationSubBlocks/list#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/compute/docs/reference/rest/v1/reservationSubBlocks/list#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/compute/docs/reference/rest/v1/reservationSubBlocks/list#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/compute/docs/reference/rest/v1/reservationSubBlocks/list#body.request_body)
- [Response body](https://docs.cloud.google.com/compute/docs/reference/rest/v1/reservationSubBlocks/list#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/reservationSubBlocks/list#body.ReservationSubBlocksListResponse.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/reservationSubBlocks/list#body.ReservationSubBlocksListResponse.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/reservationSubBlocks/list#body.ReservationSubBlocksListResponse.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION_1)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/reservationSubBlocks/list#body.ReservationSubBlocksListResponse.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION_2)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/reservationSubBlocks/list#body.ReservationSubBlocksListResponse.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION_3)
      - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/reservationSubBlocks/list#body.ReservationSubBlocksListResponse.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION_3.accelerator_topology_info.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/reservationSubBlocks/list#body.ReservationSubBlocksListResponse.SCHEMA_REPRESENTATION.warning.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/compute/docs/reference/rest/v1/reservationSubBlocks/list#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/compute/docs/reference/rest/v1/reservationSubBlocks/list#body.aspect_1)
- [Try it!](https://docs.cloud.google.com/compute/docs/reference/rest/v1/reservationSubBlocks/list#try-it)

Retrieves a list of reservation subBlocks under a single reservation.

### HTTP request

Choose an endpoint:
global africa-south1 asia-east1 asia-east2 asia-northeast1 asia-northeast2 asia-northeast3 asia-south1 asia-south2 asia-southeast1 asia-southeast2 asia-southeast3 australia-southeast1 australia-southeast2 europe-central2 europe-north1 europe-north2 europe-southwest1 europe-west1 europe-west10 europe-west12 europe-west2 europe-west3 europe-west4 europe-west6 europe-west8 europe-west9 me-central1 me-central2 me-west1 northamerica-northeast1 northamerica-northeast2 northamerica-south1 southamerica-east1 southamerica-west1 us-central1 us-east1 us-east4 us-east5 us-south1 us-west1 us-west2 us-west3 us-west4   
`GET https://compute.googleapis.com/compute/v1/projects/{project}/zones/{zone}/{parentName=reservations/*/reservationBlocks/*}/reservationSubBlocks`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `project` | `string` Project ID for this request. |
| `zone` | `string` Name of the zone for this request. Zone name should conform to RFC1035. |
| `parentName` | `string` The name of the parent reservation and parent block. In the format of reservations/{reservationName}/reservationBlocks/{reservation_block_name} |

### Query parameters

| Parameters ||
|---|---|
| `maxResults` | `integer (https://developers.google.com/discovery/v1/type-format format)` The maximum number of results per page that should be returned. If the number of available results is larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`) |
| `pageToken` | `string` Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list request to get the next page of results. |
| `filter` | `string` A filter expression that filters resources listed in the response. Most Compute resources support two types of filter expressions: expressions that support regular expressions and expressions that follow API improvement proposal [AIP-160](https://google.aip.dev/160). These two types of filter expressions cannot be mixed in one request. If you want to use AIP-160, your expression must specify the field name, an operator, and the value that you want to use for filtering. The value must be a string, a number, or a boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or `:`. For example, if you are filtering Compute Engine instances, you can exclude instances named `example-instance` by specifying `name != example-instance`. The `:*` comparison can be used to test whether a key has been defined. For example, to find all objects with `owner` label use: labels.owner:* You can also filter nested fields. For example, you could specify `scheduling.automaticRestart = false` to include instances only if they are not scheduled for automatic restarts. You can use filtering on nested fields to filter based on [resource labels](https://docs.cloud.google.com/compute/docs/labeling-resources). To filter on multiple expressions, provide each separate expression within parentheses. For example: (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") By default, each expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For example: (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true) If you want to use a regular expression, use the `eq` (equal) or `ne` (not equal) operator against a single un-parenthesized expression with or without quotes or against multiple parenthesized expressions. Examples: `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'` `fieldname eq "double quoted literal"` `(fieldname1 eq literal) (fieldname2 ne "literal")` The literal value is interpreted as a regular expression using Google [RE2](https://github.com/google/re2/wiki/Syntax) library syntax. The literal value must match the entire field. For example, to filter for instances that do not end with name "instance", you would use `name ne .*instance`. You cannot combine constraints on multiple fields using regular expressions. |
| `orderBy` | `string` Sorts list results by a certain order. By default, results are returned in alphanumerical order based on the resource name. You can also sort results in descending order based on the creation timestamp using `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse chronological order (newest result first). Use this to sort resources like operations so that the newest operation is returned first. Currently, only sorting by `name` or `creationTimestamp desc` is supported. |
| `returnPartialSuccess` | `boolean` Opt-in for partial success behavior which provides partial results in case of failure. The default value is false. For example, when partial success behavior is enabled, aggregatedList for a single zone scope either returns all resources in the zone or no resources, with an error code. |

### Request body

The request body must be empty.

### Response body

A list of reservation subBlocks under a single reservation.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "kind": string, "id": string, "items": [ { "kind": string, "id": string, "creationTimestamp": string, "name": string, "zone": string, "selfLink": string, "selfLinkWithId": string, "count": integer, "inUseCount": integer, "reservationSubBlockMaintenance": { "upcomingGroupMaintenance": { "type": enum, "canReschedule": boolean, "windowStartTime": string, "windowEndTime": string, "latestWindowStartTime": string, "maintenanceStatus": enum, "maintenanceOnShutdown": boolean, "maintenanceReasons": [ enum ] }, "maintenanceOngoingCount": integer, "maintenancePendingCount": integer, "schedulingType": enum, "subblockInfraMaintenanceOngoingCount": integer, "subblockInfraMaintenancePendingCount": integer, "instanceMaintenanceOngoingCount": integer, "instanceMaintenancePendingCount": integer }, "status": enum, "physicalTopology": { "cluster": string, "block": string, "subBlock": string }, "inUseHostCount": integer, "healthInfo": { "healthStatus": enum, "healthyHostCount": integer, "degradedHostCount": integer, "healthyInfraCount": integer, "degradedInfraCount": integer }, "acceleratorTopologiesInfo": { "acceleratorTopologyInfos": [ { "acceleratorTopology": string, "infoPerTopologyStates": [ { "state": enum, "count": integer } ] } ] } } ], "nextPageToken": string, "selfLink": string, "warning": { "code": enum, "message": string, "data": [ { "key": string, "value": string } ] } } ``` |

| Fields ||
|---|---|
| `kind` | `string` Type of the resource. Always `compute#reservationSubBlock` for a list of reservation subBlocks. |
| `id` | `string` Unique identifier for the resource; defined by the server. |
| `items[]` | `object` A list of reservation subBlock resources. |
| `items[].kind` | `string` Output only. Type of the resource. Always `compute#reservationSubBlock` for reservation subBlocks. |
| `items[].id` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. The unique identifier for the resource. This identifier is defined by the server. |
| `items[].creationTimestamp` | `string` Output only. Creation timestamp in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `items[].name` | `string` Output only. The name of this reservation subBlock generated by Google Compute Engine. The name must be 1-63 characters long, and comply with RFC1035 @pattern [a-z](https://docs.cloud.google.com/compute/docs/reference/rest/v1/reservationSubBlocks/list?:%5B-a-z0-9%5D%7B0,61%7D%5Ba-z0-9%5D)? |
| `items[].zone` | `string` Output only. Zone in which the reservation subBlock resides. |
| `items[].selfLink` | `string` Output only. Server-defined fully-qualified URL for this resource. |
| `items[].selfLinkWithId` | `string` Output only. Server-defined URL for this resource with the resource id. |
| `items[].count` | `integer` Output only. The number of hosts that are allocated in this reservation subBlock. |
| `items[].inUseCount` | `integer` Output only. The number of instances that are currently in use on this reservation subBlock. |
| `items[].reservationSubBlockMaintenance` | `object` Output only. Maintenance information for this reservation subBlock. |
| `items[].reservationSubBlockMaintenance.upcomingGroupMaintenance` | `object` Maintenance information on this group of VMs. |
| `items[].reservationSubBlockMaintenance.upcomingGroupMaintenance.type` | `enum` Defines the type of maintenance. |
| `items[].reservationSubBlockMaintenance.upcomingGroupMaintenance.canReschedule` | `boolean` Indicates if the maintenance can be customer triggered. |
| `items[].reservationSubBlockMaintenance.upcomingGroupMaintenance.windowStartTime` | `string` The current start time of the maintenance window. This timestamp value is in RFC3339 text format. |
| `items[].reservationSubBlockMaintenance.upcomingGroupMaintenance.windowEndTime` | `string` The time by which the maintenance disruption will be completed. This timestamp value is in RFC3339 text format. |
| `items[].reservationSubBlockMaintenance.upcomingGroupMaintenance.latestWindowStartTime` | `string` The latest time for the planned maintenance window to start. This timestamp value is in RFC3339 text format. |
| `items[].reservationSubBlockMaintenance.upcomingGroupMaintenance.maintenanceStatus` | `enum` |
| `items[].reservationSubBlockMaintenance.upcomingGroupMaintenance.maintenanceOnShutdown` | `boolean` Indicates whether the UpcomingMaintenance will be triggered on VM shutdown. |
| `items[].reservationSubBlockMaintenance.upcomingGroupMaintenance.maintenanceReasons[]` | `enum` The reasons for the maintenance. Only valid for vms. |
| `items[].reservationSubBlockMaintenance.maintenanceOngoingCount` | `integer` Progress for ongoing maintenance for this group of VMs/hosts. Describes number of hosts in the block that have ongoing maintenance. |
| `items[].reservationSubBlockMaintenance.maintenancePendingCount` | `integer` Progress for ongoing maintenance for this group of VMs/hosts. Describes number of hosts in the block that have pending maintenance. |
| `items[].reservationSubBlockMaintenance.schedulingType` | `enum` The type of maintenance for the reservation. |
| `items[].reservationSubBlockMaintenance.subblockInfraMaintenanceOngoingCount` | `integer` Describes number of subblock Infrastructure that has ongoing maintenance. Here, Subblock Infrastructure Maintenance pertains to upstream hardware contained in the Subblock that is necessary for a VM Family(e.g. NVLink Domains). Not all VM Families will support this field. |
| `items[].reservationSubBlockMaintenance.subblockInfraMaintenancePendingCount` | `integer` Describes number of subblock Infrastructure that has pending maintenance. Here, Subblock Infrastructure Maintenance pertains to upstream hardware contained in the Subblock that is necessary for a VM Family (e.g. NVLink Domains). Not all VM Families will support this field. |
| `items[].reservationSubBlockMaintenance.instanceMaintenanceOngoingCount` | `integer` Describes number of instances that have ongoing maintenance. |
| `items[].reservationSubBlockMaintenance.instanceMaintenancePendingCount` | `integer` Describes number of instances that have pending maintenance. |
| `items[].status` | `enum` Output only. Status of the reservation subBlock. |
| `items[].physicalTopology` | `object` Output only. The physical topology of the reservation subBlock. |
| `items[].physicalTopology.cluster` | `string` The cluster name of the reservation subBlock. |
| `items[].physicalTopology.block` | `string` The hash of the capacity block within the cluster. |
| `items[].physicalTopology.subBlock` | `string` The hash of the capacity sub-block within the capacity block. |
| `items[].inUseHostCount` | `integer` Output only. Number of hosts currently in use. If there is one or more Instances running on the host, it is considered in use. |
| `items[].healthInfo` | `object` Output only. Health information for the reservation subBlock. |
| `items[].healthInfo.healthStatus` | `enum` The health status of the reservation subBlock. |
| `items[].healthInfo.healthyHostCount` | `integer` The number of healthy hosts in the reservation subBlock. |
| `items[].healthInfo.degradedHostCount` | `integer` The number of degraded hosts in the reservation subBlock. |
| `items[].healthInfo.healthyInfraCount` | `integer` The number of healthy infrastructure (e.g NV link domain) in the reservation subblock. |
| `items[].healthInfo.degradedInfraCount` | `integer` The number of degraded infrastructure (e.g NV link domain) in the reservation subblock. |
| `items[].acceleratorTopologiesInfo` | `object` Output only. Slice info for the reservation subBlock. |
| `items[].acceleratorTopologiesInfo.acceleratorTopologyInfos[]` | `object` Info for each accelerator topology. |
| `items[].acceleratorTopologiesInfo.acceleratorTopologyInfos[].acceleratorTopology` | `string` The accelerator topology. |
| `items[].acceleratorTopologiesInfo.acceleratorTopologyInfos[].infoPerTopologyStates[]` | `object` Info for each topology state. |
| `items[].acceleratorTopologiesInfo.acceleratorTopologyInfos[].infoPerTopologyStates[].state` | `enum` The state of the accelerator topology. |
| `items[].acceleratorTopologiesInfo.acceleratorTopologyInfos[].infoPerTopologyStates[].count` | `integer` The number of accelerator topologies in this state. |
| `nextPageToken` | `string` This token allows you to get the next page of results for list requests. If the number of results is larger than `maxResults`, use the `nextPageToken` as a value for the query parameter `pageToken` in the next list request. Subsequent list requests will have their own `nextPageToken` to continue paging through the results. |
| `selfLink` | `string` Server-defined URL for this resource. |
| `warning` | `object` Informational warning message. |
| `warning.code` | `enum` Output only. A warning code, if applicable. For example, Compute Engine returns `NO_RESULTS_ON_PAGE` if there are no results in the response. |
| `warning.message` | `string` Output only. A human-readable description of the warning code. |
| `warning.data[]` | `object` Output only. Metadata about this warning in `key: value` format. For example: ```html "data": [  {  "key": "scope",  "value": "zones/us-east1-d"  }] ``` <br /> |
| `warning.data[].key` | `string` Output only. A key that provides more detail on the warning being returned. For example, for warnings where there are no results in a list request for a particular zone, this key might be `scope` and the key value might be the zone name. Other examples might be a key indicating a deprecated resource and a suggested replacement, or a warning about invalid network settings (for example, if an instance attempts to perform IP forwarding but is not enabled for IP forwarding). |
| `warning.data[].value` | `string` Output only. A warning data value corresponding to the key. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/compute.readonly`
- `
  https://www.googleapis.com/auth/compute`
- `
  https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

In addition to any permissions specified on the fields above, authorization requires one or more of the following [IAM](https://cloud.google.com/iam/docs/) permissions:

- `compute.reservationSubBlocks.list`

To find predefined roles that contain those permissions, see [Compute Engine IAM Roles](https://docs.cloud.google.com/compute/docs/access/iam).